# -*- coding: utf-8 -*-
#
# plugins/MoviePoster/__init__.py
# Copyright (C) 2013 Brent Meyer <burgermeyer64@gmail.com> 
#
# This file is a plugin for EventGhost.
#
# EventGhost is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License version 2 as published by the
# Free Software Foundation;
#
# EventGhost is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

eg.RegisterPlugin(
    name = "MoviePoster",
    guid = '{3B51BC0D-A030-4BF1-9E54-EBC3C236F583}',
    author = "Brent Meyer",
    version = "0.0.1",
    kind = "program",
	createMacrosOnAdd = True,
    description = "MoviePoster Control via http commands",
    url = "",
)

import eg
import urllib

class MoviePosterPlugin(eg.PluginClass):
    
    def __init__(self):
		self.AddAction(ToggleTrailer)
		self.AddAction(Previous)
		self.AddAction(Next)
		self.AddAction(TogglePause)
		self.AddAction(AutoplayTrailersOn)
		self.AddAction(AutoplayTrailersOff)
		self.AddAction(Play)
		self.AddAction(Pause)
		self.AddAction(enableCustomList)
		self.AddAction(disableCustomList)
		self.AddAction(showNowPlaying)
		self.AddAction(cacheOnlinePosters)
		self.AddAction(decreaseVolume)
		self.AddAction(increaseVolume)
		self.AddAction(muteOn)
		self.AddAction(muteOff)
		self.AddAction(quit)
		self.AddAction(shutdown)
		self.AddAction(minimize)
		self.AddAction(reboot)
        
    def __start__(self, hostname, port):
        self.hostname = hostname
        self.port = port

    def __stop__(self):
        print "Disconnected from MoviePoster."
    
    def __close__(self):
        print "MoviePoster plugin is now closed."
		
    def doControl(self, command):
		urllib.urlopen("http://"+self.hostname+":"+self.port+"/remote.html?Control("+command+")")

		
    def Configure(self, hostname="localhost", port="8082"):
        panel = eg.ConfigPanel()
		
        hostnameTextControl = panel.TextCtrl(hostname)
        portTextControl = panel.TextCtrl(port)
       

        sizer = wx.FlexGridSizer(rows=3, cols=2, hgap=10, vgap=5)
        sizer.Add(panel.StaticText("MoviePoster Host: "))
        sizer.Add(hostnameTextControl)  
        sizer.Add(panel.StaticText("MoviePoster Port: "))
        sizer.Add(portTextControl)
        
        border = wx.BoxSizer()
        border.Add(sizer, 0, wx.ALL, 10)
        panel.SetSizerAndFit(border)
		
        while panel.Affirmed():
            panel.SetResult(
                hostnameTextControl.GetValue(),
                portTextControl.GetValue(),
            )
			

class Next(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("Next")

class Previous(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("Previous")

class ToggleTrailer(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("Trailer")

class TogglePause(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("PlayPause")

class AutoplayTrailersOn(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("AutoplayTrailersOn")
class AutoplayTrailersOff(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("AutoplayTrailersOff")

class Play(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("Play")
class Pause(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("Pause")
class enableCustomList(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("enableCustomList")
class disableCustomList(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("disableCustomList")
class showNowPlaying(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("showNowPlaying")
class cacheOnlinePosters(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("cacheOnlinePosters")
class decreaseVolume(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("decreaseVolume")
class increaseVolume(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("increaseVolume")
class muteOff(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("muteOff")
class muteOn(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("muteOn")
class quit(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("quit")
class shutdown(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("shutdown")
class reboot(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("reboot")
class minimize(eg.ActionClass):
	
    def __call__(self):
        self.plugin.doControl("minimize")

		
		
	